#ifndef ALLOC_SUPPORT_H
#define ALLOC_SUPPORT_H

/*
 *  Include-Datei AllocSupport.h fr AllocSupport.c
 *
 *  $VER: AllocSupport.h 1.0  D. Ghler (11.07.94)
 */

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef EXEC_MEMORY_H
#include <exec/memory.h>
#endif

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif

#ifndef CLIB_EXEC_PROTOS_H
#include <clib/exec_protos.h>
#endif

#ifndef CLIB_ALIB_PROTOS_H
#include <clib/alib_protos.h>
#endif

struct MemHeader *AllocMemHeader(ULONG Size, ULONG Flags);
void FreeMemHeader(struct MemHeader *mh);
void *AllocateVec(struct MemHeader *mh, ULONG len);
void DeallocateVec(struct MemHeader *mh, APTR mem);

#endif /* ALLOC_SUPPORT_H */
