#ifndef POOL_SUPPORT_H
#define POOL_SUPPORT_H

#ifndef ALLOC_SUPPORT_H
#include "AllocSupport.h"
#endif

#ifndef MIN
#define MIN(x,y)  ((x<y) ? (x) : (y))
#define MAX(x,y)  ((x>y) ? (x) : (y))
#endif

/*
 * Pro Pool mu man sich die Werte merken, die bei MakePool
 * bergeben werden und die spter immer wieder gebraucht
 * werden. Diese werden in der Struktur Pool
 */

struct Pool {
    struct List      MHAnchor;    /* Ursprung Kachelliste */
    ULONG            Flags;       /* MEMF_xxx */
    ULONG            RegionSize;  /* Kachelgre */
    ULONG            NewSize;     /* neue Kachel nehmen ab */
};                                /* NewSize Byte */

void *CreatePool13(ULONG Flags,ULONG RegionSize, ULONG NewSize);
void DeletePool13(APTR MyPool);
APTR AllocPooled13(void *MyPool,ULONG Size);
void FreePooled13(void *MyPool, APTR memaddr);

#endif /* POOL_SUPPORT_H */
