#include <exec/types.h>
#include <clib/exec_protos.h>

void *AllocVec(ULONG Size, ULONG Flags)
{
   APTR  mem    = 0L;
   ULONG memlen = Size + sizeof(ULONG);

   if (mem = AllocMem(memlen,Flags))
   {  *(ULONG *)mem = memlen;
      mem = (ULONG *)mem +  1;

   }

   return mem;
}

void FreeVec(APTR mem)
{
   mem = ((ULONG *)mem - 1);

   FreeMem(mem, *(ULONG *)mem);
}

